import { TokenSwap } from "../tokenswap.js";
import { pow10 } from "../common/utils.js";
import { BridgeConfigV3ContractInstance } from "../entities.js";
import { BigNumber } from "@ethersproject/bignumber";
var BridgeConfig = /** @class */ (function () {
    function BridgeConfig() {
        this.instance = BridgeConfigV3ContractInstance();
    }
    BridgeConfig.prototype.calculateSwapFee = function (args) {
        var chainIdFrom = args.chainIdFrom, chainIdTo = args.chainIdTo, tokenFrom = args.tokenFrom, baseAmountFrom = args.amountFrom;
        var bridgeConfigIntermediateToken = TokenSwap.intermediateTokens(chainIdTo, tokenFrom, chainIdFrom).bridgeConfigIntermediateToken;
        var intermediateTokenAddress = bridgeConfigIntermediateToken.address(chainIdTo).toLowerCase();
        var multiplier = pow10(18 - tokenFrom.decimals(chainIdFrom)), amountFrom = BigNumber.from(baseAmountFrom).mul(multiplier);
        var bridgeFee = this.instance["calculateSwapFee(string,uint256,uint256)"](intermediateTokenAddress, chainIdTo, amountFrom);
        return { bridgeFee: bridgeFee, amountFrom: amountFrom };
    };
    return BridgeConfig;
}());
export { BridgeConfig };
