import { Signer } from "@ethersproject/abstract-signer";
import type { TransactionResponse } from "@ethersproject/abstract-provider";
import { BigNumber, type BigNumberish } from "@ethersproject/bignumber";
import type { PopulatedTransaction } from "@ethersproject/contracts";
export declare const MAX_APPROVAL_AMOUNT: BigNumber;
export declare type ApproveArgs = {
    spender: string;
    amount?: BigNumberish;
};
export declare type TokenParams = {
    tokenAddress: string;
    chainId: number;
};
export declare function approve(approveArgs: ApproveArgs, tokenParams: TokenParams, signer: Signer): Promise<TransactionResponse>;
export declare function buildApproveTransaction(approveArgs: ApproveArgs, tokenParams: TokenParams): Promise<PopulatedTransaction>;
export declare function balanceOf(address: string, tokenParams: TokenParams): Promise<BigNumber>;
export declare function allowanceOf(owner: string, spender: string, tokenParams: TokenParams): Promise<BigNumber>;
