import { isNil } from "../internal/utils.js";
import { ChainId } from "./chainid.js";
export var SynapseContracts;
(function (SynapseContracts) {
    var _a;
    var SynapseContract = /** @class */ (function () {
        function SynapseContract(_a) {
            var bridge = _a.bridge, bridgeZap = _a.bridgeZap;
            this.bridgeAddress = bridge;
            if (!isNil(bridgeZap)) {
                this.bridgeZapAddress = bridgeZap;
            }
        }
        return SynapseContract;
    }());
    SynapseContracts.SynapseContract = SynapseContract;
    SynapseContracts.Ethereum = new SynapseContract({
        bridge: "0x2796317b0fF8538F253012862c06787Adfb8cEb6",
        bridgeZap: "0x6571d6be3d8460CF5F7d6711Cd9961860029D85F",
    });
    SynapseContracts.Optimism = new SynapseContract({
        bridge: "0xAf41a65F786339e7911F4acDAD6BD49426F2Dc6b",
        bridgeZap: "0x470f9522ff620eE45DF86C58E54E6A645fE3b4A7",
    });
    SynapseContracts.Cronos = new SynapseContract({
        bridge: "0xE27BFf97CE92C3e1Ff7AA9f86781FDd6D48F5eE9",
        bridgeZap: "0x991adb00eF4c4a6D1eA6036811138Db4379377C2",
    });
    SynapseContracts.BSC = new SynapseContract({
        bridge: "0xd123f70AE324d34A9E76b67a27bf77593bA8749f",
        bridgeZap: "0x749F37Df06A99D6A8E065dd065f8cF947ca23697",
    });
    SynapseContracts.Polygon = new SynapseContract({
        bridge: "0x8F5BBB2BB8c2Ee94639E55d5F41de9b4839C1280",
        bridgeZap: "0xb883A9f35650ff82fdBC9Ed867e98FEd0457b584",
    });
    SynapseContracts.Fantom = new SynapseContract({
        bridge: "0xAf41a65F786339e7911F4acDAD6BD49426F2Dc6b",
        bridgeZap: "0x1c6aE197fF4BF7BA96c66C5FD64Cb22450aF9cC8",
    });
    SynapseContracts.Boba = new SynapseContract({
        bridge: "0x432036208d2717394d2614d6697c46DF3Ed69540",
        bridgeZap: "0x64B4097bCCD27D49BC2A081984C39C3EeC427a2d",
    });
    SynapseContracts.Metis = new SynapseContract({
        bridge: "0x06Fea8513FF03a0d3f61324da709D4cf06F42A5c",
        bridgeZap: "0x6571D58b3BF2469DF5878e213453E28dC1A4DA81",
    });
    SynapseContracts.Moonbeam = new SynapseContract(({
        bridge: "0x84A420459cd31C3c34583F67E0f0fB191067D32f",
        bridgeZap: "0xadA10A7474f4c71A829b55D2cB4232C281383fd5",
    }));
    SynapseContracts.Moonriver = new SynapseContract(({
        bridge: "0xaeD5b25BE1c3163c907a471082640450F928DDFE",
        bridgeZap: "0xfA28DdB74b08B2b6430f5F61A1Dd5104268CC29e",
    }));
    SynapseContracts.Arbitrum = new SynapseContract({
        bridge: "0x6F4e8eBa4D337f874Ab57478AcC2Cb5BACdc19c9",
        bridgeZap: "0x37f9aE2e0Ea6742b9CAD5AbCfB6bBC3475b3862B",
    });
    SynapseContracts.Avalanche = new SynapseContract({
        bridge: "0xC05e61d0E7a63D27546389B7aD62FdFf5A91aACE",
        bridgeZap: "0x0EF812f4c68DC84c22A4821EF30ba2ffAB9C2f3A",
    });
    SynapseContracts.DFK = new SynapseContract({
        bridge: "0xE05c976d3f045D0E6E7A6f61083d98A15603cF6A",
        bridgeZap: "0x75224b0f245Fe51d5bf47A898DbB6720D4150BA7",
    });
    SynapseContracts.Aurora = new SynapseContract({
        bridge: "0xaeD5b25BE1c3163c907a471082640450F928DDFE",
        bridgeZap: "0x2D8Ee8d6951cB4Eecfe4a79eb9C2F973C02596Ed",
    });
    SynapseContracts.Harmony = new SynapseContract({
        bridge: "0xAf41a65F786339e7911F4acDAD6BD49426F2Dc6b",
        bridgeZap: "0xB003e75f7E0B5365e814302192E99b4EE08c0DEd",
    });
    SynapseContracts.Klaytn = new SynapseContract({
        bridge: "0xAf41a65F786339e7911F4acDAD6BD49426F2Dc6b",
        bridgeZap: "0x8671A0465844a15eb7230C5dd8d6032c26c655B7",
    });
    var chainIdContractsMap = (_a = {},
        _a[ChainId.ETH] = SynapseContracts.Ethereum,
        _a[ChainId.OPTIMISM] = SynapseContracts.Optimism,
        _a[ChainId.CRONOS] = SynapseContracts.Cronos,
        _a[ChainId.BSC] = SynapseContracts.BSC,
        _a[ChainId.POLYGON] = SynapseContracts.Polygon,
        _a[ChainId.FANTOM] = SynapseContracts.Fantom,
        _a[ChainId.BOBA] = SynapseContracts.Boba,
        _a[ChainId.METIS] = SynapseContracts.Metis,
        _a[ChainId.MOONBEAM] = SynapseContracts.Moonbeam,
        _a[ChainId.MOONRIVER] = SynapseContracts.Moonriver,
        _a[ChainId.ARBITRUM] = SynapseContracts.Arbitrum,
        _a[ChainId.AVALANCHE] = SynapseContracts.Avalanche,
        _a[ChainId.DFK] = SynapseContracts.DFK,
        _a[ChainId.AURORA] = SynapseContracts.Aurora,
        _a[ChainId.HARMONY] = SynapseContracts.Harmony,
        _a[ChainId.KLAYTN] = SynapseContracts.Klaytn,
        _a);
    function contractsForChainId(chainId) { return chainIdContractsMap[chainId]; }
    SynapseContracts.contractsForChainId = contractsForChainId;
})(SynapseContracts || (SynapseContracts = {}));
